/*******************************************************************************
 * Copyright (C) 2022 Intel Corporation
 *
 * SPDX-License-Identifier: MIT
 ******************************************************************************/

#ifndef QPL_MIDDLE_LAYER_COMPRESSION_FIXED_HUFFMAN_TABLE_HPP
#define QPL_MIDDLE_LAYER_COMPRESSION_FIXED_HUFFMAN_TABLE_HPP

#include "huff_codes.h"

namespace qpl::ml::compression {

 static struct hufftables_icf fixed_hufftables = {
 {{
        {      {{{0x000,0x5}}},
               {{{0x010,0x5}}},
               {{{0x008,0x5}}},
               {{{0x018,0x5}}},
               {{{0x10004,0x5}}},
               {{{0x10014,0x5}}},
               {{{0x2000c,0x5}}},
               {{{0x2001c,0x5}}},
               {{{0x30002,0x5}}},
               {{{0x30012,0x5}}},
               {{{0x4000a,0x5}}},
               {{{0x4001a,0x5}}},
               {{{0x50006,0x5}}},
               {{{0x50016,0x5}}},
               {{{0x6000e,0x5}}},
               {{{0x6001e,0x5}}},
               {{{0x70001,0x5}}},
               {{{0x70011,0x5}}},
               {{{0x80009,0x5}}},
               {{{0x80019,0x5}}},
               {{{0x90005,0x5}}},
               {{{0x90015,0x5}}},
               {{{0xa000d,0x5}}},
               {{{0xa001d,0x5}}},
               {{{0xb0003,0x5}}},
               {{{0xb0013,0x5}}},
               {{{0xc000b,0x5}}},
               {{{0xc001b,0x5}}},
               {{{0xd0007,0x5}}},
               {{{0xd0017,0x5}}},
               {{{0x000,0x0}}}
        },
        {         {{{0x00c,0x8}}},
                  {{{0x08c,0x8}}},
                  {{{0x04c,0x8}}},
                  {{{0x0cc,0x8}}},
                  {{{0x02c,0x8}}},
                  {{{0x0ac,0x8}}},
                  {{{0x06c,0x8}}},
                  {{{0x0ec,0x8}}},
                  {{{0x01c,0x8}}},
                  {{{0x09c,0x8}}},
                  {{{0x05c,0x8}}},
                  {{{0x0dc,0x8}}},
                  {{{0x03c,0x8}}},
                  {{{0x0bc,0x8}}},
                  {{{0x07c,0x8}}},
                  {{{0x0fc,0x8}}},
                  {{{0x002,0x8}}},
                  {{{0x082,0x8}}},
                  {{{0x042,0x8}}},
                  {{{0x0c2,0x8}}},
                  {{{0x022,0x8}}},
                  {{{0x0a2,0x8}}},
                  {{{0x062,0x8}}},
                  {{{0x0e2,0x8}}},
                  {{{0x012,0x8}}},
                  {{{0x092,0x8}}},
                  {{{0x052,0x8}}},
                  {{{0x0d2,0x8}}},
                  {{{0x032,0x8}}},
                  {{{0x0b2,0x8}}},
                  {{{0x072,0x8}}},
                  {{{0x0f2,0x8}}},
                  {{{0x00a,0x8}}},
                  {{{0x08a,0x8}}},
                  {{{0x04a,0x8}}},
                  {{{0x0ca,0x8}}},
                  {{{0x02a,0x8}}},
                  {{{0x0aa,0x8}}},
                  {{{0x06a,0x8}}},
                  {{{0x0ea,0x8}}},
                  {{{0x01a,0x8}}},
                  {{{0x09a,0x8}}},
                  {{{0x05a,0x8}}},
                  {{{0x0da,0x8}}},
                  {{{0x03a,0x8}}},
                  {{{0x0ba,0x8}}},
                  {{{0x07a,0x8}}},
                  {{{0x0fa,0x8}}},
                  {{{0x006,0x8}}},
                  {{{0x086,0x8}}},
                  {{{0x046,0x8}}},
                  {{{0x0c6,0x8}}},
                  {{{0x026,0x8}}},
                  {{{0x0a6,0x8}}},
                  {{{0x066,0x8}}},
                  {{{0x0e6,0x8}}},
                  {{{0x016,0x8}}},
                  {{{0x096,0x8}}},
                  {{{0x056,0x8}}},
                  {{{0x0d6,0x8}}},
                  {{{0x036,0x8}}},
                  {{{0x0b6,0x8}}},
                  {{{0x076,0x8}}},
                  {{{0x0f6,0x8}}},
                  {{{0x00e,0x8}}},
                  {{{0x08e,0x8}}},
                  {{{0x04e,0x8}}},
                  {{{0x0ce,0x8}}},
                  {{{0x02e,0x8}}},
                  {{{0x0ae,0x8}}},
                  {{{0x06e,0x8}}},
                  {{{0x0ee,0x8}}},
                  {{{0x01e,0x8}}},
                  {{{0x09e,0x8}}},
                  {{{0x05e,0x8}}},
                  {{{0x0de,0x8}}},
                  {{{0x03e,0x8}}},
                  {{{0x0be,0x8}}},
                  {{{0x07e,0x8}}},
                  {{{0x0fe,0x8}}},
                  {{{0x001,0x8}}},
                  {{{0x081,0x8}}},
                  {{{0x041,0x8}}},
                  {{{0x0c1,0x8}}},
                  {{{0x021,0x8}}},
                  {{{0x0a1,0x8}}},
                  {{{0x061,0x8}}},
                  {{{0x0e1,0x8}}},
                  {{{0x011,0x8}}},
                  {{{0x091,0x8}}},
                  {{{0x051,0x8}}},
                  {{{0x0d1,0x8}}},
                  {{{0x031,0x8}}},
                  {{{0x0b1,0x8}}},
                  {{{0x071,0x8}}},
                  {{{0x0f1,0x8}}},
                  {{{0x009,0x8}}},
                  {{{0x089,0x8}}},
                  {{{0x049,0x8}}},
                  {{{0x0c9,0x8}}},
                  {{{0x029,0x8}}},
                  {{{0x0a9,0x8}}},
                  {{{0x069,0x8}}},
                  {{{0x0e9,0x8}}},
                  {{{0x019,0x8}}},
                  {{{0x099,0x8}}},
                  {{{0x059,0x8}}},
                  {{{0x0d9,0x8}}},
                  {{{0x039,0x8}}},
                  {{{0x0b9,0x8}}},
                  {{{0x079,0x8}}},
                  {{{0x0f9,0x8}}},
                  {{{0x005,0x8}}},
                  {{{0x085,0x8}}},
                  {{{0x045,0x8}}},
                  {{{0x0c5,0x8}}},
                  {{{0x025,0x8}}},
                  {{{0x0a5,0x8}}},
                  {{{0x065,0x8}}},
                  {{{0x0e5,0x8}}},
                  {{{0x015,0x8}}},
                  {{{0x095,0x8}}},
                  {{{0x055,0x8}}},
                  {{{0x0d5,0x8}}},
                  {{{0x035,0x8}}},
                  {{{0x0b5,0x8}}},
                  {{{0x075,0x8}}},
                  {{{0x0f5,0x8}}},
                  {{{0x00d,0x8}}},
                  {{{0x08d,0x8}}},
                  {{{0x04d,0x8}}},
                  {{{0x0cd,0x8}}},
                  {{{0x02d,0x8}}},
                  {{{0x0ad,0x8}}},
                  {{{0x06d,0x8}}},
                  {{{0x0ed,0x8}}},
                  {{{0x01d,0x8}}},
                  {{{0x09d,0x8}}},
                  {{{0x05d,0x8}}},
                  {{{0x0dd,0x8}}},
                  {{{0x03d,0x8}}},
                  {{{0x0bd,0x8}}},
                  {{{0x07d,0x8}}},
                  {{{0x0fd,0x8}}},
                  {{{0x013,0x9}}},
                  {{{0x113,0x9}}},
                  {{{0x093,0x9}}},
                  {{{0x193,0x9}}},
                  {{{0x053,0x9}}},
                  {{{0x153,0x9}}},
                  {{{0x0d3,0x9}}},
                  {{{0x1d3,0x9}}},
                  {{{0x033,0x9}}},
                  {{{0x133,0x9}}},
                  {{{0x0b3,0x9}}},
                  {{{0x1b3,0x9}}},
                  {{{0x073,0x9}}},
                  {{{0x173,0x9}}},
                  {{{0x0f3,0x9}}},
                  {{{0x1f3,0x9}}},
                  {{{0x00b,0x9}}},
                  {{{0x10b,0x9}}},
                  {{{0x08b,0x9}}},
                  {{{0x18b,0x9}}},
                  {{{0x04b,0x9}}},
                  {{{0x14b,0x9}}},
                  {{{0x0cb,0x9}}},
                  {{{0x1cb,0x9}}},
                  {{{0x02b,0x9}}},
                  {{{0x12b,0x9}}},
                  {{{0x0ab,0x9}}},
                  {{{0x1ab,0x9}}},
                  {{{0x06b,0x9}}},
                  {{{0x16b,0x9}}},
                  {{{0x0eb,0x9}}},
                  {{{0x1eb,0x9}}},
                  {{{0x01b,0x9}}},
                  {{{0x11b,0x9}}},
                  {{{0x09b,0x9}}},
                  {{{0x19b,0x9}}},
                  {{{0x05b,0x9}}},
                  {{{0x15b,0x9}}},
                  {{{0x0db,0x9}}},
                  {{{0x1db,0x9}}},
                  {{{0x03b,0x9}}},
                  {{{0x13b,0x9}}},
                  {{{0x0bb,0x9}}},
                  {{{0x1bb,0x9}}},
                  {{{0x07b,0x9}}},
                  {{{0x17b,0x9}}},
                  {{{0x0fb,0x9}}},
                  {{{0x1fb,0x9}}},
                  {{{0x007,0x9}}},
                  {{{0x107,0x9}}},
                  {{{0x087,0x9}}},
                  {{{0x187,0x9}}},
                  {{{0x047,0x9}}},
                  {{{0x147,0x9}}},
                  {{{0x0c7,0x9}}},
                  {{{0x1c7,0x9}}},
                  {{{0x027,0x9}}},
                  {{{0x127,0x9}}},
                  {{{0x0a7,0x9}}},
                  {{{0x1a7,0x9}}},
                  {{{0x067,0x9}}},
                  {{{0x167,0x9}}},
                  {{{0x0e7,0x9}}},
                  {{{0x1e7,0x9}}},
                  {{{0x017,0x9}}},
                  {{{0x117,0x9}}},
                  {{{0x097,0x9}}},
                  {{{0x197,0x9}}},
                  {{{0x057,0x9}}},
                  {{{0x157,0x9}}},
                  {{{0x0d7,0x9}}},
                  {{{0x1d7,0x9}}},
                  {{{0x037,0x9}}},
                  {{{0x137,0x9}}},
                  {{{0x0b7,0x9}}},
                  {{{0x1b7,0x9}}},
                  {{{0x077,0x9}}},
                  {{{0x177,0x9}}},
                  {{{0x0f7,0x9}}},
                  {{{0x1f7,0x9}}},
                  {{{0x00f,0x9}}},
                  {{{0x10f,0x9}}},
                  {{{0x08f,0x9}}},
                  {{{0x18f,0x9}}},
                  {{{0x04f,0x9}}},
                  {{{0x14f,0x9}}},
                  {{{0x0cf,0x9}}},
                  {{{0x1cf,0x9}}},
                  {{{0x02f,0x9}}},
                  {{{0x12f,0x9}}},
                  {{{0x0af,0x9}}},
                  {{{0x1af,0x9}}},
                  {{{0x06f,0x9}}},
                  {{{0x16f,0x9}}},
                  {{{0x0ef,0x9}}},
                  {{{0x1ef,0x9}}},
                  {{{0x01f,0x9}}},
                  {{{0x11f,0x9}}},
                  {{{0x09f,0x9}}},
                  {{{0x19f,0x9}}},
                  {{{0x05f,0x9}}},
                  {{{0x15f,0x9}}},
                  {{{0x0df,0x9}}},
                  {{{0x1df,0x9}}},
                  {{{0x03f,0x9}}},
                  {{{0x13f,0x9}}},
                  {{{0x0bf,0x9}}},
                  {{{0x1bf,0x9}}},
                  {{{0x07f,0x9}}},
                  {{{0x17f,0x9}}},
                  {{{0x0ff,0x9}}},
                  {{{0x1ff,0x9}}},
                  {{{0x000,0x7}}},
                  {{{0x040,0x7}}},
                  {{{0x020,0x7}}},
                  {{{0x060,0x7}}},
                  {{{0x010,0x7}}},
                  {{{0x050,0x7}}},
                  {{{0x030,0x7}}},
                  {{{0x070,0x7}}},
                  {{{0x008,0x7}}},
                  {{{0x048,0x7}}},
                  {{{0x028,0x7}}},
                  {{{0x068,0x7}}},
                  {{{0x018,0x7}}},
                  {{{0x058,0x7}}},
                  {{{0x038,0x7}}},
                  {{{0x078,0x7}}},
                  {{{0x004,0x7}}},
                  {{{0x044,0x7}}},
                  {{{0x024,0x7}}},
                  {{{0x064,0x7}}},
                  {{{0x014,0x7}}},
                  {{{0x054,0x7}}},
                  {{{0x034,0x7}}},
                  {{{0x074,0x7}}},
                  {{{0x003,0x8}}},
                  {{{0x083,0x8}}},
                  {{{0x043,0x8}}},
                  {{{0x0c3,0x8}}},
                  {{{0x023,0x8}}},
                  {{{0x0a3,0x8}}},
                  {{{0x063,0x8}}},
                  {{{0x0e3,0x8}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}},
                  {{{0x000,0x0}}}
        }
    }}
};

} // namespace qpl::ml::compression

#endif // QPL_MIDDLE_LAYER_COMPRESSION_FIXED_HUFFMAN_TABLE_HPP
